;----------------------------------------------------------------------------
; Sega Master System & Game Gear basic definitions
; by Omar Cornut / Bock|Zoop (c) in February 2001
;----------------------------------------------------------------------------

; MEMORY --------------------------------------------------------------------
PAGE0           = $0000
PAGE1           = $4000
PAGE2           = $8000
RAM             = $C000
RAM_LEN         = $1FF8
RAM_MIRROR      = $E000
REG_MAP_SRAM    = $FFFC
REG_MAP_0       = $FFFD
REG_MAP_1       = $FFFE
REG_MAP_2       = $FFFF
;----------------------------------------------------------------------------

; VIDEO ---------------------------------------------------------------------
VDP_DATA        = $BE
VDP_ADDR        = $BF
VDP_STATUS      = $BF
VRAM_TILES      = $0000
VRAM_BG_MAP     = $3800
VRAM_SPR_MAP    = $3F00
VRAM_SPR_LAST   = 208
;----------------------------------------------------------------------------
VRAM_SIZE       = $4000
VRAM_TILE_SIZE  = 32            ; (8 * 8) * 4 bits = 32 bytes
;----------------------------------------------------------------------------
VREG_CONFIG0    = $80
VREG_CONFIG1    = $81
; ..
VREG_BORDER_COL = $87
VREG_HSCROLL    = $88
VREG_VSCROLL    = $89
VREG_LINES_CNT  = $8A
;----------------------------------------------------------------------------

; INPUTS --------------------------------------------------------------------
PORT_INPUT1     = $DC
P1_UP           = $01
P1_DOWN         = $02
P1_LEFT         = $04
P1_RIGHT        = $08
P1_BUTTON1      = $10
P1_BUTTON2      = $20
P2_UP           = $40
P2_DOWN         = $80
;----------------------------------------------------------------------------
PORT_INPUT2     = $DD
P2_LEFT         = $01
P2_RIGHT        = $02
P2_BUTTON1      = $04
P2_BUTTON2      = $08
RESET_BUTTON    = $10
; Unused        = $20
LIGHTGUN1       = $40
LIGHTGUN2       = $80
;----------------------------------------------------------------------------
PORT_INPUTGG    = $00
START_BUTTON    = $80
;----------------------------------------------------------------------------

; SOUND ---------------------------------------------------------------------
PORT_PSG        = $7F
PORT_FM_ADDR    = $F0
PORT_FM_DATA    = $F1
PORT_FM_LATCH   = $F2
;----------------------------------------------------------------------------

; MISCELLANEOUS -------------------------------------------------------------
PORT_NATION     = $3F
PORT_VLINE      = $7E
PORT_HLINE      = $7F
;----------------------------------------------------------------------------

; HEADER --------------------------------------------------------------------
HEADER          = $7FF0
HEADER_ID       = $7FF0 ; TMR SEGA
; ..
HEADER_CHECKSUM = $7FFA
; ..
HEADER_SYS_SIZE = $7FFF
;----------------------------------------------------------------------------

